# -*- coding: utf-8 -*-
#
################################################################################################## SOF
#
#      /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::.
#    /mMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNd-
#   -MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN`
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmNMMMMMMMMMMMmMMMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh:NMMMMMMMMMMoyMMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMm -NMMMMMMMMMs.NMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy  -hmmmmmNNm- sMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmdyo+:`   ```````.`  .NMMMymMMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmy+-.`                    -hNm-+MMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMms:`                          `.. /MMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh/.                                 /MMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMmMMMMMMMMMMMmhN:`                                   /MMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMM+sNMMMMMMMMMN-h:         `-+syyys/-                 -NMMMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMs +NMMMMMMMhm--d`  :.  -sdNMMMMMNNmy.                :ydMMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMM+  :yhyyyhhso` os  yhshNMMMMMMMh+:-:.  :s-             .NMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMMMMmho`          `   `yo.h:sMMMMMMMMMMNd+.   -NNs-            yMMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMMMNh/.                   :++`-MMMMMMMMMMMMMm+`  :ymds.          -NMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMMMmo-                          .MMMMMMMMMMMMMMMdo.  `.-`           yMMMMMMMMMMMMMMMM-
#   /MMMMMMMMMmo.                            `NMMMMMMMMMMMMMMMMNy/.`             `mMMMMMMMMMMMMMMM-
#   /MMMMMMMNs.                               hMMMMMMMMMMMMMMMMMMMNho-`           :NMMMMMMMMMMMMMM-
#   /MMMMMMm:        ./syyyo-                 -hmNMMMMMMMMMMMMMMMMMMMMmho:.`       /NMMMMMMMMMMMMM-
#   /MMMMMd.       .smMMMNNNms`  `              `+MMMMMMMMMMMMMMMMMMMMMMMMNdy/    `.yMMMMMMMMMMMMM-
#   /MMMMd.       /mMMMMMy/:--`  so.             `mMMMMMMMMMMMMMMMMMMMMMMMNdo--:+sdNMMMMMMMMMMMMMM-
#   /MMMN-       /NMMMMMMMMdo.   oMm+.            /MMMMMMMMMMMMMMMMdNMMMMMMNNNMMmMMMMMMMMMMMMMMMMM-
#   /MMMo       -NMMMMMMMMMMdso-` /hmm+            sMMMMMMMMMMMMMMMs-mMMMMMMMMMM:dMMMMMMMMMMMMMMMM-
#   /MMN.       sMMMMMMMMMMMo .os/.``..            `dMMMMMMMMMMMMMMs -NMMMMMMMMM-:MMMMMMMMMMMMMMMM-
#   /MMd        mMMMMMMMMMMM/   `:os+-`             .dMMMMMMMMMMMNm.  -soosyhdms `mMMMMMMMMMMMMMMM-
#   /MMs        mMMMMMMMMMMM:       .hNhs/.`         .dMMMMNmhs+:-`               +MMMNoMMMMMMMMMM-
#   /MMy        hMMMMMMMMMMM:        oMMMMMNdyo/.     .mNh+-`                      +mNy`mMMMMMMMMM-
#   /MMd        +MMMMMMMMMMM/        :MMMMMMMMNs.`.:ohh/`                            `  mMMMMMMMMM-
#   /MMN.       `mMMMMMMMMMMo        `NMMMMMMNhhdNMMh:                                  mMMMMMMMMM-
#   /MMM+        /MMMMMMMMMMh         yMMMMMMMMMMMN+                                   `NMMMMMMMMM-
#   /MMMm`        +MMMMMMMMMN`        .NMMMMMMMMMN-         :sdmNNNdy+`                 dMMMMMMMMM-
#   /MMMMo         +MMMMMMMMM+         +MMMMMMMMM/        -dMMMMMMNmmNN/                .sdMMMMMMM-
#   /MMMMN:         :mMMMMMMMm`         oMMMMMMMh        .mMMMMMMMms- ``  /o`             `mMMMMMM-
#   /MMMMMm.         .yMMMMMMMo          oMMMMMM/        sMMMMMMMMMMMh:   :NNo.            sMMMMMM-
#   /MMMMMMm.          -hMMMMMN:          /NMMMM.        dMMMMMMMMMMMMMh-  :hmNy`          .NMMMMM-
#   /MMMMMMMm-           -yNMMMm.          .yMMM.        dMMMMMMMMMMMMMMNh:` `..`           yMMMMM-
#   /MMMMMMMMN+            .+hNMd.           :hM:        dMMMMMMMMMMMMMMMMNmo-              .NMMMM-
#   /MMMMMMMMMMh-             ./ss.           `::        sMMMMMMMMMMMMMMMMMMMNms/.           /MMMM-
#   /MMMMMMMMMMMNo.              `                       :MMMMMMMMMMMMMMMMMMMMMMMNdo:.`       oMMM-
#   /MMMMMMMMMMMMMmo.                                    `mMMMMMMMMMMMMMMMMMMMMMMMMMMNmh:     .dMM-
#   /MMMMMMMMMMMMMMMNy:`                                  +MMMMMMMMMMMMMMMMMMMMMMMMMMNh+::/+sdNMMM-
#   /MMMMMMMMMMMMMMMMMNdo-                                `dMMMMMMMMMMMMMMMMMMMMMMMMMNNNNNMMMMMMMM-
#   /MMMMMMMMMMMMMMMMMMMMNd+-`                             -NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM-
#   -NMMMMMMMMMMMMMMMMMMMMMMNdo:`                           /NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMd`
#    -ymNNNNNNNNNNNNNNNNNNNNNNNNdo-`                         +NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNmy.
#      ............................                           .-..............................*/
#       ``````       `````````          ``````````````          ``````````              ``````
######################################################################################################
#
#  NOTES
######################################################################################################
# > sudo apt install python3-pip
# > cat << EOF > requirements.txt
# requests
# bs4
# ipdb
# EOF
# > python3 -m pip install -r requirements.txt
######################################################################################################

# STAGE 0 - OVERLAY
from sys import exit,argv
from os import getcwd,path,remove
import signal
from rich.console import Console
from rich.color import ANSI_COLOR_NAMES
from random import choice
import ipdb

# STAGE 1 - FETCH LFS PACKAGES
from requests.exceptions import HTTPError
from urllib.request import Request, urlopen
from urllib.error import URLError, HTTPError
from bs4 import BeautifulSoup
import requests
import urllib3
import shutil


# STAGE 2 - AUTOMATE EXTRACTIONS
from os import system
from time import sleep

######################################################################################################
class C:
    ################################################################################################## <<<<<<<<<<<<<<<<<<<<<<<< BBBB
    def __init__(self,mirrors=[]):
        self.LOGINIT=0
        self.LOGFILE="dr1pt_pr0be.log"
        self.USER_AGENT_BROWSER="Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.103 Safari/537.36"
        self.mirrors_packages=[]
        self.mirrors_packages_versions=[]
        self.colors=[]
        for _ in ANSI_COLOR_NAMES:
            if _.lower().find('black') == -1:
                self.colors.append(_)
        for i,_ in enumerate(mirrors):
            mirrors[i]=f"{_}/lfs-packages"
        self.mirrors=mirrors
        try:
            self.mirrors_len=len(max(self.mirrors,key=len))+1
        except:
            self.mirrors_len=1
        self.lfs_packages_filename=""
        self.drive=argv[1]
        self.main()                                                                                  # <<<<<<<<<<<<<<<<<<<<<<<< BBCC
    ################################################################################################## <<<<<<<<<<<<<<<<<<<<<<<< EEEE
    def parse_RESPONSE(self,RESPONSE,SITE):
        soup=BeautifulSoup(RESPONSE.text,"html.parser")
        pretty=soup.prettify()
        lfs_packages_versions=[]
        lfs_packages=[]
        STATUS=4 # ERROR NO OPERATION
        try:
            for _ in pretty.splitlines():
                if _.find('<') == -1 and not _.find('lfs-packages') == -1 and not _.find('.') == -1:
                    loot=_.strip()
                    self.l0g(f"FOUND: LOOT - {loot}")
                    version_0=loot.split('packages-')[1].split('.tar')[0].split('.')[0].zfill(4)
                    buffer=[]
                    for _ in loot.split('packages-')[1].split('.tar')[0].split('.')[1:]: 
                        buffer.append(_.zfill(4))
                    version_1=buffer
                    lfs_packages_versions.append([version_0,version_1])
                    lfs_packages.append(loot)
                    STATUS=2 # OK DISCOVERED LOOT
        except:
            STATUS=3 # ERROR DIDN'T DISCOVER LOOT
        try:
            self.mirrors_packages.append(lfs_packages)
            self.mirrors_packages_versions.append(lfs_packages_versions)
            STATUS=0 # OK GOT VERSION NUMBERS FROM LOOT
        except:
            STATUS=1 # ERROR PARSING VERSION NUMBERS FROM LOOT
        return STATUS
    ################################################################################################## <<<<<<<<<<<<<<<<<<<<<<<< DDDD
    def GET_LFS_PACKAGES(self,SITE,SESSION):
        url=f"{SITE}"
        response=None
        self.INDICATE('PROBE',1,url)
        try:
            response=SESSION.get(url)
            response.raise_for_status()
        except HTTPError as http_err:
            self.INDICATE('ERROR',2,url,str(response.status_code),http_err)
        except Exception as err:
            self.INDICATE('ERROR',3,url,str(response.status_code),err)
        return response
    ################################################################################################## <<<<<<<<<<<<<<<<<<<<<<<< CCCC
    def FETCH_HTTP_FILE(self,url):
        PATH=getcwd()
        NAME=url.split('/')[-1]
        filename=f"{PATH}/{NAME}"
        http = urllib3.PoolManager()
        self.l0g(f"DOWNLOADING - {filename}")
        with open(filename,'wb') as out:
            r = http.request('GET',url,preload_content=False)
            shutil.copyfileobj(r,out)
        self.l0g(f"STORED FILE - {filename}")
        self.lfs_packages_filename=filename
    ##################################################################################################
    def main(self):
        with requests.Session() as SESSION:
            RESPONSE=-1
            for SITE in self.mirrors:
                try:
                    RESPONSE=self.GET_LFS_PACKAGES(SITE,SESSION)                                     # <<<<<<<<<<<<<<<<<<<<<<<< CCDD
                    STATUS=self.parse_RESPONSE(RESPONSE,SITE)                                        # <<<<<<<<<<<<<<<<<<<<<<<< DDEE
                    if RESPONSE.status_code == 200:
                        if STATUS==0:
                            self.INDICATE('OK',5,str(SITE),str(RESPONSE.status_code),str(STATUS))
                except Exception as err:
                    self.INDICATE('ERROR',4,str(SITE),str(RESPONSE.status_code),str(err))
            #EXTRACT HIGHEST VERSION NUMBER LFS PACKAGE BETWEEN THE MIRRORS
            v0=[]; v1=[];
            try:
                for i in range(len(self.mirrors_packages_versions)):
                    self.mirrors_packages_versions[i].sort()
                    v0.append(self.mirrors_packages_versions[i][-1][0])
                    v1.append(self.mirrors_packages_versions[i][-1][1])
            except:
                self.l0g('error in version assessment')
            v0.sort(); v1.sort();
            v0=int(v0[-1]); v1=v1[-1];
            for i,_ in enumerate(v1):                
                if v1[i].lower().find('rc')==-1: v1[i]=int(v1[i])
            filename='lfs-packages-'
            filename+=f"{v0}."
            for _ in v1:
                filename+=f"{_}."
            filename+='tar'      
            url=f"{self.mirrors[0]}/{filename}"
            self.l0g(f'LFS_PACKAGE - {url}')
            self.FETCH_HTTP_FILE(url)
    ################################################################################################## <<<<<<<<<<<<<<<<<<<<<<<< DDDD
    def INDICATE(self,s='STATUS',n=0,a1="",a2="",a3=""):
        b=""
        if n==1:
            s="PROBE: SITE - "
            b=self.scram(b,s,len(s))
            s=a1
            b=self.scram(b,s,len(s)+5*2)
            b=self.scram(b,"",5*2)
            self.l0g(b)
        elif n==2:
            s="ERR0R: SITE - "
            b=self.scram(b,s,len(s)+5*1)
            b=self.scram(b,"",5*2)
            s=a1
            b=self.scram(b,s,len(s)+5*2)
            b=self.scram(b,"",5*2)
            s="- CODE - "
            b=self.scram(b,s,len(s)+5*1)
            s=a2
            b=self.scram(b,s,len(s)+5*2)
            b=self.scram(b,"",5*1)
            s="INFO - "
            b=self.scram(b,s,len(s)+5*1)
            s=a3
            b=self.scram(b,s,len(s)+5*2)
            self.l0g(b)
        elif n==3:
            s="ERROR: SITE - "
            b=self.scram(b,s,len(s)+5*1)
            b=self.scram(b,"",5*2)
            s=a1
            b=self.scram(b,s,len(s)+5*2)
            b=self.scram(b,"",5*2)
            s="- CODE - "
            b=self.scram(b,s,len(s)+5*1)
            s=a2
            b=self.scram(b,s,len(s)+5*2)
            b=self.scram(b,"",5*1)
            s="INFO - "
            b=self.scram(b,s,len(s)+5*1)
            s=a3
            b=self.scram(b,s,len(s)+5*2)
            self.l0g(b)
        elif n==4:
            s="3RR0R: SITE - "
            b=self.scram(b,s,len(s))
            s=a1
            b=self.scram(b,s,self.mirrors_len)
            s="- CODE - "
            b=self.scram(b,s,len(s))
            try:
                s=a2
            except:
                s="ERR"
            b=self.scram(b,s,5)
            s="- INFO - "
            b=self.scram(b,s,len(s))
            s=a3
            try:
                b=self.scram(b,s,len(s)+1)
            except:
                s='ERROR'
                b=self.scram(b,s,len(s))
            self.l0g(b)
        elif n==5:
            s="BINGO: SITE - "
            b=self.scram(b,s,len(s))
            s=a1
            b=self.scram(b,s,self.mirrors_len)
            s="- CODE - "
            b=self.scram(b,s,len(s))
            s=a2
            b=self.scram(b,s,4)
            s="- STATUS - "
            b=self.scram(b,s,len(s))
            s=a3
            b=self.scram(b,s,len(s)+5*2)
            self.l0g(b)
    #$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ $$$$$$$$$$$$$$$$$$$$$$$$$ MISC-FUNCTION
    def findall(self,s,w):
        return [i for i in range(len(s)) if s.startswith(w,i)]
    #$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ $$$$$$$$$$$$$$$$$$$$$$$$$ MISC-FUNCTION
    def l0g(self,s):
        c=Console()
        if not self.LOGINIT:
            if path.isfile(self.LOGFILE): remove(self.LOGFILE)
            f=open(self.LOGFILE,'w');f.write('');f.close();self.LOGINIT=1;
        f=open(self.LOGFILE,'a');f.write(f'{s}\n');f.close();
        _s=s.split()
        s=''
        for _ in _s:
            color=choice(self.colors)
            msg=f'[{color}]{_}[/{color}]'
            s+=f'{msg} '
        c.print(s)
        # _s=''
        # for _ in s:
        #     color=choice(self.colors)
        #     msg=f'[{color}]{_}[/{color}]'
        #     _s+=f'{msg}'
        # c.print(_s)
    #$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ $$$$$$$$$$$$$$$$$$$$$$$$$ MISC-FUNCTION
    def scram(self,s,ss,x):
        _x=len(ss)
        if _x < x:
            __x=x-_x
            return f"{s}{ss}{' '*__x}"
        else:
            return f"{s}{ss[0:x]}"
###################################################################################################### TRAPPING SIGNAL OVERLAY
def signal_handler(sig, frame):
    ###############    
    exit(0)
###################################################################################################### TRAPPING SIGNAL OVERLAY
class TMUX:
    ###############    
    def __init__(self,SESSION='dr1pt'):
        self.SESSION=SESSION
    ###############    
    def keys(self,s):
        cmd=f'tmux send-keys -t {self.SESSION} "{s}" Enter'
        system(cmd)
    ###############    
    def keys_enter(self,n=1):
        for i in range(n):
            cmd=f'tmux send-keys -t {self.SESSION} Enter'
            system(cmd)
            sleep(1)
    ###############    
    def win(self,s,n=0):    
        if s.lower()=='split':
            cmd=f'tmux split-window -v -t {self.SESSION}'
            system(cmd)
        elif s.lower()=="kill":
            cmd=f'tmux kill-pane -t {n}'
            system(cmd)
    ###############    
###################################################################################################### <<<<<<<<<<<<<<<<<<<<<<<< AAAA
if __name__ == "__main__":
    ############### STAGE 0
    signal.signal(signal.SIGINT,signal_handler)
    ############### STAGE 1
    MIRRORS=["http://ftp.lfs-matrix.net/pub/lfs",
            "http://ftp.osuosl.org/pub/lfs",
            "http://mirror.jaleco.com/lfs/pub/lfs"]
    print('\nFETCHING NEWEST LFS PACKAGES')
    sleep(1)
    dr1p=C(MIRRORS)                                                                                  # <<<<<<<<<<<<<<<<<<<<<<<< AABB
    ############### STAGE 2
    tmux=TMUX('dr1pt')
    tmux.win('split')
    keys=[]
    keys.append("cat .external/.motd2")
    dr1p.l0g('\nEXTRACTING LFS PACKAGES')
    sleep(1)
    keys.append(f"tar xvf {dr1p.lfs_packages_filename}")
    keys.append("mv 11.0 lfs_packages")
    keys.append("bash .external/version_check.sh;echo")
    dr1p.l0g('\nCREATING NEW PARTITION TABLE AND EFI/SWAP/ROOT PARTITIONS')
    sleep(1)
    keys.append(f"fdisk -l {dr1p.drive}")
    keys.append(f"fdisk {dr1p.drive} << EOF\ng\np\nn\n1\n\n+256M\nt\n1\nn\n2\n\n+4G\nt\n2\n19\nn\n3\n\n\nw\nEOF")
    for _ in map(tmux.keys,keys): _
    dr1p.l0g('\nSLEEPING 30 SECONDS TO WAIT FOR DISK SYNC')
    sleep(30)
    tmux.win('kill',1)
    tmux.win('split')
    dr1p.l0g('\nUNMOUNTING DRIVES JUST IN CASE THEY AUTOMOUNTED')
    sleep(1)
    keys.append(f"umount {dr1p.drive}1")
    keys.append(f"umount {dr1p.drive}2")    
    keys.append(f"umount {dr1p.drive}3")    
    dr1p.l0g('\nFORMATTING THE NEW PARTITIONS')
    sleep(1)
    keys=[]
    keys.append("export LFS=/mnt/lfs")
    keys.append("export ALFS=/mnt/lfs/alfs;echo")
    keys.append(f"yes|mkfs.fat -F 32 {dr1p.drive}1")
    keys.append(f"yes|mkswap {dr1p.drive}2")
    keys.append(f"yes|mkfs.ext4 -F {dr1p.drive}3")
    dr1p.l0g('\nREMOVING OLD WORKPATH IF IT EXISTS')
    sleep(1)
    keys.append(f"rm -Rf /mnt/lfs")    
    keys.append("mkdir \$LFS")
    keys.append(f"mount -t ext4 {dr1p.drive}3 \$LFS")
    keys.append(f"echo YOLO")
    for _ in map(tmux.keys,keys): _
    tmux.keys_enter(5)
######################################################################################################
# /*MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh+MMMMMMMMMMMMMMhsMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMm/ oMMMMMMMMMMMMMMm +NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy`  yMMMMMMMMMMMMMMM- -mMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMs+dMMMMMMMMMM+    sMMMMMMMMMMMMMMM-  `dMMMMMMMMMMms/NMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMM+ .omMMMMMM:     -MMMMMMMMMMMMMMo    `yMMMMMMMy: `dMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMM-   /dMMM+       sMMMMMMMMMMMMh      `hMMMNo`   sMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMd     :dm        `mMMMMMMMMMMN.       .NNo`    .MMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMM:      -         :MMMMMMMMMMs         :`      sMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMs                 ymNMMMMMNm.                 NMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMy                    `-/-`                   .MMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMo                                            .NMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMNh+.                                               :sdMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMhso+:.                                                      `-/+syMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMM-                                                                 dMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMM`   `.:+/.                                              `/s+:.    sMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMNo   -oms.             .//-`               `:/:`            `+md+`  .hMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMNs`                        .odNdo.       .ohmd+`                        :dMMMMMMMMMMMMM
# MMMMMMMMMMMNo`                             ..           .-                             :hMMMMMMMMMMM
# MMMMMMMMMd+`                                                                             -sNMMMMMMMM
# MMMMMMNs-                         `..                          `/-.                        `+dMMMMMM
# MMMNy:                       ./sdNMMMh:                      `sNMMMNds/.                      .odMMM
# MM+                       :ymMMMMMMMMMMh.                   +NMMMMMMMMMMmo-                      /NM
# MMMh:                  .sNMMMMMMMMMMMMMMN-                `hMMMMMMMMMMMMMMMm+`                 :hMMM
# MMMMMd:`       ``-:+shmMMMMMMMMMMMMMMMMMMN.               hMMMMMMMMMMMMMMMMMMMmhs+/-..``````./dMMMMM
# MMMMMMMMMNNNNNNMMMMMMMMMMMMMMMMMMMMMMMMMMMo              .MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy              .MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN.             /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN+`         `+NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNs.    -hMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMdyymMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM*/
################################################################################################## EOF